#include "MK21DA5.h"

const uint32_t led_mask[] = {1UL << 4, 1UL << 5, 1UL << 6, 1UL << 7};

/* Initialize LEDs*/

void LED_Init(void){

  SIM->SCGC5   |= (1UL << 12);           // Enable Clock on Port D
  PORTD->PCR[4] = (1UL <<  8);           // Configure pins as GPIO
  PORTD->PCR[5] = (1UL <<  8);                     
  PORTD->PCR[6] = (1UL <<  8);
  PORTD->PCR[7] = (1UL <<  8);

  PTD->PDOR = (led_mask[0] |             
               led_mask[1] |
               led_mask[2] |
               led_mask[3] );            // Turn all LEDs off

  PTD->PDDR = (led_mask[0] | 
               led_mask[1] | 
               led_mask[2] |
               led_mask[3] );           // Enable GPIO as output
			   
}
/* LED_Toggle */
void LED_Toggle(uint32_t led) {
	PTD->PDOR ^= led_mask[led];
}

/* Turn LED on/off*/

void LED_On (uint32_t led) {

  PTD->PCOR   = led_mask[led];
}

 void LED_Off (uint32_t led) {

  PTD->PSOR   = led_mask[led];
}