#include "MK22F51212.h"

const uint32_t led_mask[] = {1UL << 1, 1UL << 2, 1UL << 5};

/* Initialize LEDs*/

void LED_Init(void){

  SIM->SCGC5   |= ((1UL << 12) | (1UL << 9)); // Enable Clock on Port A & D
  PORTA->PCR[1] = (1UL <<  8);              // Configure pins as GPIO
  PORTA->PCR[2] = (1UL <<  8);                     
  PORTD->PCR[5] = (1UL <<  8);
 

  PTD->PDOR = (led_mask[0] |             
               led_mask[1] |
               led_mask[2] );            // Turn all LEDs off

  PTD->PDDR = (led_mask[0] | 
               led_mask[1] | 
               led_mask[2] );           // Enable GPIO as output
			   
}
/* LED_Toggle */
void LED_Toggle(uint32_t led) {
	PTD->PDOR ^= led_mask[led];
}

/* Turn LED on/off*/

void LED_On (uint32_t led) {

  PTD->PCOR   = led_mask[led];
}

 void LED_Off (uint32_t led) {

  PTD->PSOR   = led_mask[led];
}