
#define BIT_MASK(x)   (0x1<<x)

// User should only define wich port and the bit 


#define LED1_PORT   B   // RED LED
#define LED1_BIT    8

#define LED2_PORT   B   // GREEN LED
#define LED2_BIT    9

#define LED3_PORT   B   // BLUE LED  
#define LED3_BIT    10

// Compilation time Definitions

#define PCR(PTO,BIT)  PORT##PTO##_PCR##BIT
#define PDDR(PTO)     GPIO##PTO##_PDDR
#define PSOR(PORT)    GPIO##PORT##_PSOR
#define PCOR(PORT)    GPIO##PORT##_PCOR
#define PTOR(PORT)    GPIO##PORT##_PTOR
#define PDOR(PORT)    GPIO##PORT##_PDOR
#define PDIR(PORT)    GPIO##PORT##_PDIR



#define  PCR_OUTPUT_CONFIG  (PORT_PCR_MUX(1) | PORT_PCR_DSE_MASK ) //Pin configured as GPIO
#define  PCR_INPUT_CONFIG   (PORT_PCR_MUX(1) | PORT_PCR_PE_MASK | PORT_PCR_PS_MASK) //Pin configured as GPIO Input with pull up enable


#ifdef  LED1_PORT
#define LED1
#define LED1_PCR_OUTPUT(LED1_PORT,LED1_BIT)  PCR(LED1_PORT,LED1_BIT)
#define LED1_DDR_OUTPUT(LED1_PORT,LED1_BIT)  PDDR(LED1_PORT) |= (1<<LED1_BIT)
#define LED1_PSOR(LED1_PORT,LED1_BIT)        PSOR(LED1_PORT) |= (1<<LED1_BIT)
#define LED1_PCOR(LED1_PORT,LED1_BIT)        PCOR(LED1_PORT) |= (1<<LED1_BIT)
#define LED1_PTOR(LED1_PORT,LED1_BIT)        PTOR(LED1_PORT) |= (1<<LED1_BIT)

#define LED1_PCR        LED1_PCR_OUTPUT(LED1_PORT,LED1_BIT) 
#define LED1_OUTPUT_EN  LED1_DDR_OUTPUT(LED1_PORT,LED1_BIT) 

#define LED1_SET         LED1_PSOR(LED1_PORT,LED1_BIT)
#define LED1_CLR         LED1_PCOR(LED1_PORT,LED1_BIT)

#define LED1_ON         LED1_PCOR(LED1_PORT,LED1_BIT)
#define LED1_OFF        LED1_PSOR(LED1_PORT,LED1_BIT)
#define LED1_TOGGLE     LED1_PTOR(LED1_PORT,LED1_BIT)
#endif


#ifdef  LED2_PORT
#define LED2
#define LED2_PCR_OUTPUT(LED2_PORT,LED2_BIT)  PCR(LED2_PORT,LED2_BIT)
#define LED2_DDR_OUTPUT(LED2_PORT,LED2_BIT)  PDDR(LED2_PORT) |= (1<<LED2_BIT)
#define LED2_PSOR(LED2_PORT,LED2_BIT)        PSOR(LED2_PORT) |= (1<<LED2_BIT)
#define LED2_PCOR(LED2_PORT,LED2_BIT)        PCOR(LED2_PORT) |= (1<<LED2_BIT)
#define LED2_PTOR(LED2_PORT,LED2_BIT)        PTOR(LED2_PORT) |= (1<<LED2_BIT)

#define LED2_PCR         LED2_PCR_OUTPUT (LED2_PORT,LED2_BIT)
#define LED2_OUTPUT_EN   LED2_DDR_OUTPUT (LED2_PORT,LED2_BIT)

#define LED2_SET      LED2_PSOR(LED2_PORT,LED2_BIT)
#define LED2_CLR      LED2_PCOR(LED2_PORT,LED2_BIT)

#define LED2_ON       LED2_PCOR(LED2_PORT,LED2_BIT)
#define LED2_OFF      LED2_PSOR(LED2_PORT,LED2_BIT)
#define LED2_TOGGLE   LED2_PTOR(LED2_PORT,LED2_BIT)
#endif

#ifdef  LED3_PORT
#define LED3
#define LED3_PCR_OUTPUT(LED3_PORT,LED3_BIT)  PCR(LED3_PORT,LED3_BIT)
#define LED3_DDR_OUTPUT(LED3_PORT,LED3_BIT)  PDDR(LED3_PORT) |= (1<<LED3_BIT)
#define LED3_PSOR(LED3_PORT,LED3_BIT)        PSOR(LED3_PORT) |= (1<<LED3_BIT)
#define LED3_PCOR(LED3_PORT,LED3_BIT)        PCOR(LED3_PORT) |= (1<<LED3_BIT)
#define LED3_PTOR(LED3_PORT,LED3_BIT)        PTOR(LED3_PORT) |= (1<<LED3_BIT)

#define LED3_PCR        LED3_PCR_OUTPUT (LED3_PORT,LED3_BIT)
#define LED3_OUTPUT_EN   LED3_DDR_OUTPUT (LED3_PORT,LED3_BIT)

#define LED3_CLR       LED3_PCOR(LED3_PORT,LED3_BIT) //Led turn with positive
#define LED3_SET       LED3_PSOR(LED3_PORT,LED3_BIT)

#define LED3_OFF       LED3_PSOR(LED3_PORT,LED3_BIT) //Led turn with positive
#define LED3_ON        LED3_PCOR(LED3_PORT,LED3_BIT)
#define LED3_TOGGLE   LED3_PTOR(LED3_PORT,LED3_BIT)
#endif

void  gpio_init(void);

