#include "MKV31F51212.h"

const uint32_t led_mask[] = {1UL << 0, 1UL << 1};

/* Initialize LEDs - only red and orange on PTE0/1 */

void LED_Init(void){

  SIM->SCGC5   |= (1UL << 13);           // Enable Clock on Port E
  PORTE->PCR[0] = (1UL <<  8);           // Configure pins as GPIO
  PORTE->PCR[1] = (1UL <<  8);                     

  PTE->PDOR = (led_mask[0] |             
               led_mask[1] );            // Turn all LEDs off

  PTE->PDDR = (led_mask[0] | 
               led_mask[1] );           // Enable GPIO as output
			   
}
/* LED_Toggle */
void LED_Toggle(uint32_t led) {
	PTE->PDOR ^= led_mask[led];
}

/* Turn LED on/off*/

void LED_On (uint32_t led) {

  PTE->PCOR   = led_mask[led];
}

 void LED_Off (uint32_t led) {

  PTE->PSOR   = led_mask[led];
}